/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.*;

/**
 * @author Сергей
 */
public class MIDPCanvas extends GameCanvas implements Runnable,CommandListener{
private Sprite mCursor;
private Thread mThread;
private Image mImage; //холст для рисования на нем блок-схемы 
private int mX,mY; //координаты для холста    
private Command mCom1,mCom2,mCom3,mCom4,mCom5,mCom6,mCom7,mCom8,mCom9,mCom10,mCom11,mCom12,mCom13; //команды с названиями элементов
private Command mSave; 
private Image mImg1,mImg2,mImg3,mImg4,mImg5,mImg6,mImg7,mImg8,mImg9,mImg10,mImg11,mImg12,mImgCls; //картинки с элементами

private Form mTextForm; //форма для ввода текста для вставки
private Command mOk; //команда для формы ввода текста для вставки 
private TextField mTextField; //поле ввода для текста для вставки

private Form mPathForm; //форма для ввода пути для сохранения
private TextField mPathField; //поле ввода пути для сохранения


/**
     * constructor
     */
    public MIDPCanvas() {
    super(true); 
    try{
    mCursor=new Sprite(Image.createImage("/cursor.png"));
    mThread=new Thread(this);
    mImage=Image.createImage(200,300);
    mCom1=new Command("<старт>",Command.OK,0);
    mCom2=new Command("<действия>",Command.OK,0);
    mCom3=new Command("<условие>",Command.OK,0);
    mCom4=new Command("<модуль>",Command.OK,0);
    mCom5=new Command("<ввод-вывод>",Command.OK,0);
    mCom6=new Command("<соединитель>",Command.OK,0);
    mCom7=new Command("<верт.линия>",Command.OK,0);
    mCom8=new Command("<гориз.линия>",Command.OK,0);
    mCom9=new Command("<стрел.влево>",Command.OK,0);
    mCom10=new Command("<стрел.вверх>",Command.OK,0);
    mCom11=new Command("<стрел.вправо>",Command.OK,0);
    mCom12=new Command("<стрел.вниз>",Command.OK,0);
    mCom13=new Command("<текст>",Command.OK,0);
    mSave=new Command("сохр.схему",Command.EXIT,0);
    this.addCommand(mCom1);
    this.addCommand(mCom2);
    this.addCommand(mCom3);
    this.addCommand(mCom4);
    this.addCommand(mCom5);
    this.addCommand(mCom6);
    this.addCommand(mCom7);
    this.addCommand(mCom8);
    this.addCommand(mCom9);
    this.addCommand(mCom10);
    this.addCommand(mCom11);
    this.addCommand(mCom12);
    this.addCommand(mCom13);
    this.addCommand(mSave);
    this.setCommandListener(this);
    mImg1=Image.createImage("/1.png");
    mImg2=Image.createImage("/2.png");
    mImg3=Image.createImage("/3.png");
    mImg4=Image.createImage("/4.png");
    mImg5=Image.createImage("/5.png");
    mImg6=Image.createImage("/6.png");
    mImg7=Image.createImage("/7.png");
    mImg8=Image.createImage("/8.png");
    mImg9=Image.createImage("/9.png");
    mImg10=Image.createImage("/10.png");
    mImg11=Image.createImage("/11.png");
    mImg12=Image.createImage("/12.png");
    mImgCls=Image.createImage("/cls.png");
    mTextForm=new Form("Вставка текста");
    mOk=new Command("далее",Command.OK,0);
    mTextField=new TextField("введите текст для вставки","",20,TextField.ANY);
    mTextForm.addCommand(mOk);
    mTextForm.append(mTextField);
    mTextForm.setCommandListener(this);
    
    mPathForm=new Form("Сохранение");
    mPathField=new TextField("введите путь к файлу","c:/1.png",100,TextField.ANY);
    mPathForm.append(mPathField);
    mPathForm.addCommand(mOk);
    mPathForm.setCommandListener(this);
    
    
    }catch(Exception e){}
    }

    public void start(Display d){
    d.setCurrent(this);
    mThread.start();
    mX=0;
    mY=0;
    mCursor.setPosition((getWidth()/2)-20,(getHeight()/2)-20);
    }
    
    
    public void run(){
    while(true){
    draw(getGraphics());
    checkKey();
    try{
    mThread.sleep(10);    
    }catch(Exception e){}
    }    
    }
    
    /**
     * paint
     */
    public void draw(Graphics g) {
    g.setColor(0,0,0);
    g.fillRect(0, 0, getWidth(), getHeight());
    g.drawImage(mImage, mX, mY, 20);
    mCursor.paint(g);
    flushGraphics();
    }
    
    private void checkKey(){
    int keyState=getKeyStates();
    switch(keyState){
        case UP_PRESSED: mY+=2;
                         break;
        case DOWN_PRESSED: mY-=2;
                         break;
        case LEFT_PRESSED: mX+=2;
                         break;    
        case RIGHT_PRESSED: mX-=2;
                         break;
        case FIRE_PRESSED:  mImage.getGraphics().drawImage(mImgCls,mCursor.getX()-mX,mCursor.getY()-mY,20);
                         break;
    }
    }
    
    
    public void commandAction(Command c,Displayable d){
    if (c==mCom1) mImage.getGraphics().drawImage(this.mImg1,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom2) mImage.getGraphics().drawImage(this.mImg2,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom3) mImage.getGraphics().drawImage(this.mImg3,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom4) mImage.getGraphics().drawImage(this.mImg4,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom5) mImage.getGraphics().drawImage(this.mImg5,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom6) mImage.getGraphics().drawImage(this.mImg6,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom7) mImage.getGraphics().drawImage(this.mImg7,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom8) mImage.getGraphics().drawImage(this.mImg8,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom9) mImage.getGraphics().drawImage(this.mImg9,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom10) mImage.getGraphics().drawImage(this.mImg10,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom11) mImage.getGraphics().drawImage(this.mImg11,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom12) mImage.getGraphics().drawImage(this.mImg12,mCursor.getX()-mX,mCursor.getY()-mY, 20);
    if (c==mCom13) Main.link.mDisplay.setCurrent(mTextForm);
    if (c==mOk && d==mTextForm) {
    //рисование на холсте текста и вывод игрового канваса
    mImage.getGraphics().setFont(Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL));
    mImage.getGraphics().drawString(mTextField.getString(),mCursor.getX()-mX,mCursor.getY()-mY, 20);  
    Main.link.mDisplay.setCurrent(this);
    }
    //вывод формы сохранения
    if (c==mSave) Main.link.mDisplay.setCurrent(this.mPathForm);
    if (c==mOk && d==mPathForm){
    mPathForm.append("Ждите,идет обработка и сохранение...");
    Lib_png3.save_png(mImage,this.mPathField.getString());
    Main.link.mDisplay.setCurrent(this);
    try{
    mThread.sleep(3000);    
    }catch(Exception e){}
    }
    
    
    }
    
  
    
    
    
    
    

   
}